#include <iostream>
using namespace std;

class Point {
private:
  mutable int count_writes;
  double x;
  double y;
public:
  Point() : count_writes(0),x(0.0),y(0.0) {
    cout << "he construido un origen\n";
  }

  Point(
    double x_,
    double y_
  ) :
    count_writes(0),x(x_),y(y_)
  {
    cout << "he construido un punto\n";
  }
  Point(const Point& P)
    : count_writes(0),x(P.x),y(P.y) {
    cout << "he construido una copia\n";
  }
public: 
  ~Point() {
    cout << "he destruido un punto\n";
  }

  //  q = p
  Point& operator=(const Point& P) {
    x=P.x;
    y=P.y;
    return(*this);
  }

  void Write(void) const {
    cout << "(" << x << "," << y << ")\n";
    count_writes++;
    cout << count_writes << " veces escrito\n";
  }
};

int main(
) {
  Point p;
  p.Write();
  p=Point(2.0,3.0);
  p.Write();
  Point q(p);  // q=Point(p);
  q.Write();

  return 0;
}

